Attribute VB_Name = "BatchModeDeclarations"
Option Explicit
Declare Function MYFUNC_FINDCLUSTERS Lib "c:\data\pascaldll.dll" (ByVal MaxPoints As Long, ByVal xy_thin As Double, ByVal r_limit As Double, ByRef plotdata As Double, ByRef n_tau As Long, ByRef a_tau As Single, ByRef Nclus As Long, ByRef SearchSpaceData As Double, ByRef atausum As Double, ByRef cluscoords As Double, ByRef rclus As Single, ByRef a_in As Byte, ByRef a_out As Byte) As Double
Declare Function MYFUNC_INDEXX Lib "c:\data\pascaldll.dll" (ByVal MaxPoints As Long, ByRef a_tau As Single, ByRef n_tau As Long) As Double
Public BAPPPATH As String
Public plotdata(0 To 20) As Double
Public B_plotcenter As PlotCenter
Public B_Xsol As Double, B_Ysol As Double, B_Zsol As Double
Public B_treenumber As Double
Public B_XRmin As Double, B_XRmax As Double, B_XRstep As Double
Public B_YRmin As Double, B_YRmax As Double, B_YRstep As Double
Public B_ZRmin As Double, B_ZRmax As Double, B_ZRstep As Double
Public B_TWmin As Double, B_TWmax As Double, B_TWstep As Double
Public B_ZDiffmin As Double, B_ZDiffmax As Double, B_ZDiffstep As Double
Public B_EZAmin As Double, B_EZAmax As Double, B_EZAstep As Double
Public B_ZDepthmin As Double, B_ZDepthmax As Double, B_ZDepthstep As Double
Public B_ZAsymin As Double, B_ZAsymax As Double, B_ZAsystep As Double
Public B_Meshmin As Double, B_Meshmax As Double, B_Meshstep As Double
Public B_XYthinmin As Double, B_XYthinmax As Double, B_XYthinstep As Double
Public B_Rlimitmin As Double, B_Rlimitmax As Double, B_Rlimitstep As Double
Public Sub Open_a_set_Batch()

Rem Routine for opening a set of images, setting the Main Window-layot, assigning global vars with values


Dim startrow As Long, startcol As Long, endrow As Long, endcol As Long
Dim i As Long

Rem Set the Initialize Boolean To FALSE

initialize = False

Rem Error handling at line

On Error GoTo Error_in_Open_a_set

Rem Use Commondialog1 - object to get the filename for the set-file

'CommonDialog1.DialogTitle = "Header file for an image set" '
'CommonDialog1.Filter = "Set files (*.set)|*.set"
'CommonDi alog1.Action = 1
Open "f:\images.set" For Input As 1
'Form1.Caption = CommonDialog1.filename


Rem Read a line to get the set name & display it
Input #1, ImagesetName
Input #1, BatchFileName
Input #1, DemFileName

Form1.Label1(1).Caption = ImagesetName

Rem Read a line to get the number of images in the set & display it
Input #1, NumOfImages

'Form1.List1.AddItem ImagesetName
'Form1.List1.AddItem "Number of images: " & NumOfImages

Rem Form1, the main window is maximized by default and has pixel-metrics. Get it's scalewidth & scaleheight to determine
Rem individual image window widths and heights (win_w & win_h). There'll be images in a row.

Call set_window_sizes


If NumOfImages > MAXIMA Then
 MsgBox ("At the moment cannot allow more than " & MAXIMA & " images (three rows of Picture-boxes to hold the images!)")
 Close (1)
 Exit Sub
End If

Rem Read the individual image descriptions

For i = 0 To NumOfImages - 1
 Call read_set_file_for_an_image(CLng(i))
 Rem Check the sanity of parameters for image i
 Call Check_parameter_sanity(i)
 Rem Read the description for next image i
 Form1.Check1(i).Value = 1
 DoEvents
Next i

Rem Close the SET-file as we've read all information
Close (1)

Rem Make the mouse pointer into a "tiimalasi" wait-state -one
Form1.MousePointer = 11
Rem Update label10
Form1.Label10.Caption = CStr(0) & "/" & CStr(NumOfImages) & " images read"
DoEvents

Rem There'll be (NumOfImages-1) "gimmicks" on the main window, give them their locations in pixel-metrics

Call Place_Objects_On_The_Main_Form

Rem Assign values to following integer-VARS
startrow = 0: startcol = 0
endrow = 0: endcol = 0


Rem Now starts the section where we display each sub-image cenetered at their .sub_c_col and .sub_c_row
Rem image coordinates

For i = 0 To NumOfImages - 1
 Rem To start with we assume zooming (pan) factor 1
 Rem Assign global vars ("pan" should really say "Zoom"),
 win_info(i).pan_x = 1
 win_info(i).pan_y = 1
 Rem Assign the global vars with window widths & heights
 win_info(i).win_width = Win_w
 win_info(i).win_height = win_h

Rem calculate the region from which in the sub-image (StartCol, StartRow, EndCol, EndRow) consists
Rem Centering at (sub_c_col, sub_c_row)

Call calculate_region(i, image_info(i).sub_c_col, image_info(i).sub_c_row, CInt(1 / win_info(i).pan_x * Win_w), CInt(1 / win_info(i).pan_y * win_h), startcol, startrow, endcol, endrow, win_info(i).pan_x, win_info(i).pan_y)

Rem Call create_bmp to make the BMP-file to be displayed.
Rem Check if it is a greyscale (0) image or color (1)

If image_info(i).Color = 1 Then
Rem It's a color image
Rem Wrapper for filename to be passed to the C-routine
 Dim length, j As Integer
 length = Stringlength(image_info(i).Filename)
 ReDim filename_in(0 To length) As Byte
 For j = 0 To length - 1
  filename_in(j) = CByte(Asc(Mid$(image_info(i).Filename, j + 1, 1)))
 Next j
 filename_in(length) = 0
 Dim FileOut As String
 FileOut = "c:\data\pic" & CStr(i) & ".bmp"
 length = Len(FileOut)
 ReDim filename_out(0 To length) As Byte
 For j = 0 To length - 1
  filename_out(j) = CByte(Asc(Mid$(FileOut, j + 1, 1)))
 Next j
 filename_out(length) = 0
  
Rem create_bmp written in VB
Call create_bmp(i, startcol, startrow, endcol, endrow, "c:\data\pic" & CStr(i) & ".bmp", win_info(i).pan_x, win_info(i).pan_y)

Rem Alternatively call a C-function (it is not any faster!!)
Rem Header is created separately if C-routine is used
' Call create_bmp_header(FileOut, CLng(Win_w), CLng(win_h))
Rem MYFUNC_CREATEDBMP resides in a C-dll
' apu = MYFUNC_CREATEBMP(CLng(i), CLng(startcol), CLng(startrow), CLng(endcol), CLng(endrow), filename_in(0), filename_out(0), CDbl(win_info(i).pan_x), CDbl(win_info(i).pan_y), CLng(win_h), CLng(Win_w), CLng(image_info(i).sub_width))
ElseIf image_info(i).Color = 0 Then
 Call create_BW_bmp(i, startcol, startrow, endcol, endrow, "c:\data\pic" & CStr(i) & ".bmp", win_info(i).pan_x, win_info(i).pan_y)
End If

Rem Load the image

Form1.Picture1(i).Picture = LoadPicture("c:\data\pic" & CStr(i) & ".bmp")

Form1.Label10.Caption = CStr(i + 1) & "/" & CStr(NumOfImages) & " images read"

DoEvents

Rem Make the R-matrix for image i

Call r_transform_matrix(i)

Rem Make the picture-box visible

Form1.Picture1(i).Enabled = True
Form1.Picture1(i).Visible = True

Rem Next image

Imagesdisplayed(i) = AER_IMA

Next i


Rem Assign values to X_start (if space intersection failes this will became the initial solution)
X_start = CStr(image_info(1).Xo + 5#)
Y_start = CStr(image_info(1).Yo + 2#)
Z_start = CStr(200#)
Rem cen-point is for panning the images at the wanted XYZ-point
X_cen = X_start
Y_cen = Y_start
Z_cen = Z_start

Rem Make the mousepointer into an arrow
Form1.MousePointer = 1
initialize = True

Rem Exit not to run the error-handling code
Exit Sub
Rem Error handling section
Error_in_Open_a_set:
MsgBox ("An error ocurred in Open_a_set_Click_Routine")
Form1.MousePointer = 1
Close (1)
Exit Sub

End Sub

Public Sub Run_Match_Batch()

Rem Assign value to solution and plotcenter

SolutionExists = True
Dim xd As Double, yd As Double, zd As Double

Rem Let the solution move around the tree top

For xd = B_XRmin To B_XRmax Step B_XRstep
 For yd = B_YRmin To B_YRmax Step B_YRstep
   For zd = B_ZRmin To B_ZRmax Step B_ZRstep
    X_sol = B_Xsol + xd
    Y_sol = B_Ysol + yd
    Z_sol = B_Zsol + zd
    Call Capture_templates_Batch
   Next zd
  Next yd
 Next xd

End Sub

Public Sub Read_batch_script_Batch()
Dim cdummy As String

'CommonDialog1.DialogTitle = "Batch Script file"
'CommonDialog1.Filter = "Set files (*.txt)|*.txt"
'CommonDialog1.Action = 1
'Open CommonDialog1.filename For Input As 1

Open BatchFileName For Input As 1
Input #1, cdummy
Input #1, cdummy
Input #1, B_plotcenter.Code, B_plotcenter.XYangle, B_plotcenter.x, B_plotcenter.y, B_plotcenter.z
Input #1, cdummy
Input #1, B_Xsol, B_Ysol, B_Zsol
Input #1, cdummy
Input #1, B_treenumber
Input #1, cdummy
Input #1, B_XRmin, B_XRmax, B_XRstep
Input #1, cdummy
Input #1, B_YRmin, B_YRmax, B_YRstep
Input #1, cdummy
Input #1, B_ZRmin, B_ZRmax, B_ZRstep
Input #1, cdummy
Input #1, B_TWmin, B_TWmax, B_TWstep
Input #1, cdummy
Input #1, B_ZDiffmin, B_ZDiffmax, B_ZDiffstep
Input #1, cdummy
Input #1, B_EZAmin, B_EZAmax, B_EZAstep
Input #1, cdummy
Input #1, B_ZDepthmin, B_ZDepthmax, B_ZDepthstep
Input #1, cdummy
Input #1, B_ZAsymin, B_ZAsymax, B_ZAsystep
Input #1, cdummy
Input #1, B_Meshmin, B_Meshmax, B_Meshstep
Input #1, cdummy
Input #1, B_XYthinmin, B_XYthinmax, B_XYthinstep
Input #1, cdummy
Input #1, B_Rlimitmin, B_Rlimitmax, B_Rlimitstep

Close (1)

End Sub

Public Sub Add_height_Model_Batch()


Dim i As Integer, j As Integer

On Error GoTo Error_in_Add_height_Model_Click
Close (1)
If DemFileName = "" Then
Form1.CommonDialog1.DialogTitle = "Header file for a height model"
Form1.CommonDialog1.Filter = "HDR files (*.hdr)|*.hdr"
Form1.CommonDialog1.Action = 1
DemFileName = Form1.CommonDialog1.Filename
End If

Open DemFileName For Input As 1

Form1.MousePointer = 11
DoEvents

Form1.Caption = Form1.CommonDialog1.Filename
Input #1, Zmodel.ncols
Input #1, Zmodel.nrows
Input #1, Zmodel.xllcorner
Input #1, Zmodel.yllcorner
Input #1, Zmodel.Cellsize
Input #1, Zmodel.nodata_value
Input #1, Zmodel.filepath
Close (1)


ReDim ZfXY(0 To Zmodel.ncols, 0 To Zmodel.nrows) As Single
ReDim row(0 To Zmodel.ncols) As Single
Dim place As Long

Open Zmodel.filepath For Binary As 1
For i = 0 To Zmodel.nrows - 1
 place = 1 + (i * Zmodel.ncols) * 4
  Get #1, place, row()
  For j = 0 To Zmodel.ncols - 1
   ZfXY(j, i) = row(j)
  Next j
 Next i
 Close (1)
RasterModelReady = True
Form1.Label10.Caption = " DEM read succesfully"
Form1.MousePointer = 1
DoEvents

Exit Sub
Error_in_Add_height_Model_Click:
Form1.MousePointer = 1
DoEvents
MsgBox ("An error occurred")
Form1.Label10.Caption = " DEM read unsuccesfully"
End Sub

Public Sub Capture_templates_Batch()


Rem ******************************************************************************************
Rem This routine computes ('detaches') pixels from the aerial images involved in the matching,
Rem forming an elliptic template-image for each aerial image.

Dim p_x As Double, p_y As Double
Dim x As Double, y As Double
Dim t As Double, s As Double
Dim Points(0 To MAXIMA - 1) As Point2D
Dim nadir_x As Double, nadir_y As Double
Dim cam_x As Double, cam_y As Double
Dim quart As Integer
Dim i As Integer, l As Integer, m As Integer

Rem ************* Start ******************************************
Rem Cannot proceed without a 3D-solution, check the global boolean

If SolutionExists = False Then
  MsgBox ("Need a 3D solution!")
  Exit Sub
End If

Rem Call center_to_xyz

Rem ************* 3 PARAMETERS ****************
Rem Metric parameteres defining the shape, position and size of the elliptic template, globals

For TemplateWidth = B_TWmin To B_TWmax Step B_TWstep
 For Zdiff = B_ZDiffmin To B_ZDiffmax Step B_ZDiffstep
  For EllipseZasymmetry = B_EZAmin To B_EZAmax Step B_EZAstep

  Rem Assign these values to outputvector OV
  OV.TWidth = TemplateWidth: OV.Zdiff = Zdiff: OV.EllZasym = EllipseZasymmetry
                                                           


Rem Model tree top-location, Get the global 3D-solution of manual multiple image matching
Dim TreeTop As point3D                                          ' Model tree top-location
TreeTop.x = X_sol: TreeTop.y = Y_sol: TreeTop.z = Z_sol
Rem assign these to output-vector OV
OV.ModelTreeX = TreeTop.x: OV.ModelTreeY = TreeTop.y: OV.ModelTreeZ = TreeTop.z
OV.ModelTreeNum = B_treenumber

Rem Loop thru images to compute necessary camera/pixel coordinate locations
Dim camera_x As Double, camera_y As Double
Dim camera_x1 As Double, camera_y1 As Double
Dim ima_row1 As Double, ima_col1 As Double
Dim ima_row2 As Double, ima_col2 As Double

For i = 0 To NumOfImages - 1
 Rem Get 2D-camera coordinates for the model tree top
 Call r_transform_3D(i, TreeTop.x, TreeTop.y, TreeTop.z, camera_x, camera_y)
 Rem Get 2D-camera coordinates for the model tree top adjusted in Z by EllipseZasymmetry
 Call r_transform_3D(i, TreeTop.x, TreeTop.y, TreeTop.z + EllipseZasymmetry, camera_x1, camera_y1)
 Rem Get 2D-image/pixel coordinates for these camera coordinates
 Call a_transform_affine(i, 0, camera_x, camera_y, ima_col1, ima_row1)
 Call a_transform_affine(i, 0, camera_x1, camera_y1, ima_col2, ima_row2)
 
 Rem Check if Zasymmetry causes a significant (> .5 pixel) translation, if translation necessary,
 Rem translate the template. The template still has a 'hot spot' i.e. tree top's location at
 Rem {camera_x, camera_y} photo coordinates. NOTE ! At some point get rid if Int(), pixel
 Rem coordinates in integers / not necessary really, sub-pixel accuracy allowed!
 
 If Abs(ima_col1 - ima_col2) > 0.5 Then Ellipse(i).dx_col = CInt(ima_col1 - ima_col2)
 If Abs(ima_row1 - ima_row2) > 0.5 Then Ellipse(i).dx_row = CInt(ima_row1 - ima_row2)
 
 Rem MsgBox ("Image " & i & " col-shift: " & ellipse(i).dx_col & "  row-shift: " & ellipse(i).dx_row)
 Rem To visually check that everything looks all right, superimpose the translated ellipse center
 Rem on the aerial photograph.
' Form1.Picture1(i).DrawWidth = 3
 'Form1.Picture1(i).PSet ((ima_col2 - (image_info(i).o_col + win_info(i).win_o_col)) * win_info(i).pan_x - 1, ((image_info(i).height - 1) - ima_row2 - (image_info(i).o_row + win_info(i).win_o_row)) * win_info(i).pan_y - 1), RGB(255, 0, 0)
' Form1.Picture1(i).DrawWidth = 1
 
 Rem Assign the Model tree top's camera coordinates into ellipse's center point
 Ellipse(i).x = camera_x1
 Ellipse(i).y = camera_y1
 
 Rem Compute photo-coordinates for a nadir point at Z = Z_sol (Z is irrelevant, anything with (X0,Y0,Z#)will project
 Rem to the same photo location.
 Call r_transform_3D(i, image_info(i).Xo, image_info(i).Yo, Z_sol, nadir_x, nadir_y)
 
 Rem Nadir points photo coordinates give the direction of radial displacement, in the 2D-photo coordinate xy-system.
 cam_x = camera_x - nadir_x
 cam_y = camera_y - nadir_y
 Rem alpha is the direction angle in radians [-Pi/2, Pi/2].
 Ellipse(i).alpha = MYFUNC_ATAN2(cam_y, cam_x)
 
 Rem re-using vars cam_x, cam_y, now for assigning the value at TreeTop+Zdiff to get the
 Rem length of the other ellipse-halfaxis, call it a
 Call r_transform_3D(i, TreeTop.x, TreeTop.y, TreeTop.z + Zdiff, cam_x, cam_y)
 Rem camera_x, camera_y hold the location of the TreeTop, substract to get half axis length
 Ellipse(i).a = ((cam_x - camera_x) ^ 2 + (cam_y - camera_y) ^ 2) ^ 0.5
 Rem halfaxis-b with TemplateWidth-parameter (Width = HalfWidth, Radius)
 Call r_transform_3D(i, TreeTop.x + TemplateWidth, TreeTop.y, TreeTop.z, cam_x, cam_y)
 Ellipse(i).B = ((cam_x - camera_x) ^ 2 + (cam_y - camera_y) ^ 2) ^ 0.5
 Rem Allow only halfaxis a to be larger, otherwise make ellipse into a circle
 If Ellipse(i).a < Ellipse(i).B Then Ellipse(i).a = Ellipse(i).B
 
 Rem At this point, set the image 'chosen' for template extraction. NOTE this is not necessary! In
 Rem a batch job, this statement should be rewritten.
 ' Check1(i).Value = 1
 Rem Force Zooming at 1:1
 ' Call aZoom(i, 1#, 1#)
 Rem Process Next Image
Next i


Rem At this point the ellipses are ready for extraction. Now plot ellipses on the aerial photographs
Rem for checking purposes.

Rem Loop Thru all images
For i = 0 To NumOfImages - 1
  Call CaptureEllipticTemplate(i, Ellipse(i))
Next i

'Close (222)

Form1.Label10.Caption = "Elliptic templates captured and superimposed on images"

Rem ADD HERE CALL TO COMPUTE CORRELATION IMAGES_BATCH
   Call Compute_Correlation_Images_Batch
   
  Next EllipseZasymmetry
 Next Zdiff
Next TemplateWidth
 

End Sub



Public Sub Compute_Correlation_Images_Batch()


Rem This routine is used for computing the cross-correlation images. Templates are stored in c:\temp\temp#.raw
Rem and c:\temp\temp#.img files.
Rem
Rem The raw-file stores a greyscale image in row-order (1st row, followed 2nd row, etc)
Rem The img file has parameters: Width, Height, HotSpotCol, HotSpotRow.
Rem By HotSpot is ment the location of the tree top in the template.
Rem

Dim Num_of_ima As Long, i As Long, j As Long
ReDim images_involved(1 To MAXIMA) As Long
Dim pixel_size_um As Long, pixel_size_m As Double
Dim s_width As Long, s_height As Long
Dim p_x As Double, p_y As Double
Dim CenterCol As Long, CenterRow As Long
Dim Start_Col As Long, Start_Row As Long, End_Col As Long, End_Row As Long


Rem We look for trees within bounds of a circular plot (NOTE! this could be extended a XY-polygon, forest)
Plotradius = CDbl(Form1.Text4.Text)
Rem Assign outputVector
OV.Plotradius = Plotradius
Rem The size of the correlation image patch in object coordinates, side length. This affects the size of the
Rem correlation image. We want the whole 3D-search space, when central-projected on the correlation image patch,
Rem to fall within (inside) the correlation image.
square_side = 3.8 * Plotradius

Rem If there's no 3D-solution of space intersection, leave!
If SolutionExists = False Then
 MsgBox ("Solution X;Y;Z does not exist!")
 Exit Sub
End If

Rem Check which images are involved, there's an associated check-box with every image on the main window
Num_of_ima = 0
For i = 0 To NumOfImages - 1
 If Form1.Check1(i).Value = 1 Then
  Num_of_ima = Num_of_ima + 1:
  images_involved(Num_of_ima) = i   ' The index is stored in this array
 End If
Next i

Rem obtain the approximate metrics for the images involved
For j = 1 To Num_of_ima
 i = images_involved(j)
 Rem Estimate Pixel size in micrometers from the affine transformation's coefficient determinant
 Rem which gives the area-ratio: sqrt(1/(a*e-b*d))*10^6
 pixel_size_um = sqrt((1 / (image_info(i).a_ * image_info(i).e_ - image_info(i).b_ * image_info(i).d_))) * 10 ^ 6
 Rem Estimate pixelsizein meters assuming vertical photography
 pixel_size_m = (((image_info(i).Zo - B_plotcenter.z)) * pixel_size_um) / (image_info(i).c * 10 ^ 6)
 Rem The width of the correlation image patch
 s_width = CInt(square_side / pixel_size_m)
 
 Rem Let's make s_width 101, 201, 301, 401,... (this serves debugging, max r = 1 must be at image center pixel)
 Dim ic As Integer
  For ic = 1 To 10001 Step 100
   If ic >= s_width Then
    s_width = ic
    GoTo WidthDetermined
   End If
  Next ic
MsgBox ("There's a problem defining the size of the corr-image-patch: " & images_involved(j))
WidthDetermined:
 Rem Get the coordinates (pixel) for the image patch
 ' Call r_transform_ground_to_pixel(ByVal i, X_sol, Y_sol, Z_sol, p_x, p_y) ' use this to debug (at center r=1)
 Call r_transform_ground_to_pixel(ByVal i, B_plotcenter.x, B_plotcenter.y, B_plotcenter.z, p_x, p_y)
 Rem These are the center-coordinates for the image patch in the main image pixel-coordinate system
 Rem Row-axis here 'grows downwards'.
 CenterCol = CInt(p_x - image_info(i).o_col)
 CenterRow = CInt(p_y - ((image_info(i).Height - 1) - (image_info(i).o_row + (image_info(i).sub_height - 1))))
 ' From up!
 Call calculate_region(ByVal i, CenterCol, CenterRow, s_width, s_width, Start_Col, Start_Row, End_Col, End_Row, CDbl(1#), CDbl(1#))
 
 Rem Flip Row-axis
 Start_Row = (image_info(i).sub_height - 1) - Start_Row
 End_Row = (image_info(i).sub_height - 1) - End_Row

' Start_Row and End_Row are defined in the sub-image's right-handed system, with origin at low left

 Rem For reading image data, declare arrays to hold data by rows, just in case for both color models
 ReDim RROWCOL(0 To (End_Col - Start_Col)) As RGBtriplet
 ReDim RROWBW(0 To (End_Col - Start_Col)) As Byte
 Rem Declare storage for the image patch to be converted into a correlation image
 ReDim Ima(0 To (End_Col - Start_Col), 0 To (Start_Row - End_Row)) As Byte
' Exit Sub
 Rem Delete existing correlation image c:\temp\ccor_ima#.raw
' Kill "c:\data\ccor_ima" & CStr(i) & ".raw"
 Rem Open files for I/O
 Open "c:\data\ccor_ima" & CStr(i) & ".img" For Output As 3
 Open "c:\data\ccor_ima" & CStr(i) & ".raw" For Binary As 2
 Open image_info(i).Filename For Binary As 1
 
 Dim k As Integer, ix As Integer, paikka As Long, m As Integer
 k = -1
 For ix = End_Row To Start_Row   ' Loop Rows for reading
   k = k + 1                     ' row-counter
   Rem according to color model, compute file location from where to read data
   If image_info(i).Color = 1 Then
    paikka = CLng(ix) * CLng(image_info(i).sub_width) * 3 + CLng(Start_Col) * 3
   Else
    paikka = CLng(ix) * CLng(image_info(i).sub_width) + CLng(Start_Col)
   End If
   Rem Read a row of image data
   If image_info(i).Color = 1 Then
    Get #1, paikka + 1, RROWCOL()
   Else
    Get #1, paikka + 1, RROWBW()
   End If
    Rem A row of iamge data for the patch is read
    Rem Now loop Columns for copying into array Ima()
    For m = 0 To (End_Col - Start_Col)
     If image_info(i).Color = 1 Then
      Ima(m, k) = CByte((CDbl(RROWCOL(m).R) + CDbl(RROWCOL(m).G) + CDbl(RROWCOL(m).B)) / 3#)
     Else
      Ima(m, k) = RROWBW(m)
     End If
    Next m ' Next column
  Next ix ' Next Row

Rem Image patch is obtained, write it to file
 Put #2, 1, Ima()
Rem Close opened files
Close (2)
Close (1)
Rem Print the width and height of the image patch into the header
Print #3, End_Col - Start_Col + 1
Print #3, Start_Row - End_Row + 1
Close (3)

Rem *************************
Rem Cross-correlation section
Rem *************************

Rem Open the template header, get parameters
Open "c:\data\temp" & CStr(i) & ".img" For Input As 1
Dim w_temp As Integer, h_temp As Integer, c_col As Integer, c_row As Integer
Input #1, w_temp
Input #1, h_temp
Input #1, c_col   ' Hotspot
Input #1, c_row   ' Hotspot
Close (1)

Rem Declare Storage for the template
ReDim t(0 To w_temp - 1, 0 To h_temp - 1) As Byte
Rem Declare storage for the cross-correlation image, global array
ReDim r_ima(0 To End_Col - Start_Col, 0 To Start_Row - End_Row) As Double
Rem declare storage for the display-version of the cross-correlation image
ReDim Lkuva(0 To End_Col - Start_Col, 0 To Start_Row - End_Row) As Byte

Rem Open and read the template
Open "c:\data\temp" & CStr(i) & ".raw" For Binary As 1
Get 1, , t
Close (1)

Rem Cross-correlation is computed in a dll-function, out-commented statements are used for obtaining time
Rem spent computing the cross-correlation
Dim aika1, apu As Double, aika2, nx As Integer, mx As Integer

aika1 = Timer
apu = MYFUNC_CORIMA(Ima(0, 0), ByVal End_Col - Start_Col + 1, ByVal Start_Row - End_Row + 1, t(0, 0), ByVal w_temp, ByVal h_temp, ByVal c_col, ByVal c_row, r_ima(0, 0))
aika2 = Timer - aika1
Form1.Label10.Caption = Format$(aika2, "#.00") & " Seconds cross-corr for image: " & CStr(i)

Rem Copy the double-data into Byte aray for display
For nx = 0 To End_Col - Start_Col
  For mx = 0 To Start_Row - End_Row
'   apu = (r_ima(nx, mx) + 1#) * (256 / 2)
   cor_arr(i, nx, mx) = r_ima(nx, mx)
'   If apu < 0 Then apu = 0                ' should not be the case!
'   If apu > 255 Then apu = 255            ' should not be the case!
'   Lkuva(nx, mx) = CByte(apu)
  Next mx
 Next nx


Rem Here we write extra raw-image versions of the correlations images, check that r = 1, i.e. greyscale
Rem equals 255 at center-pixel!
'Kill "c:\data\corimage" & CStr(i) & ".raw"
'Open "c:\data\corimage" & CStr(i) & ".raw" For Binary As 333
'Put #333, 1, Lkuva
'Close (333)

Rem ****************************************************************
Rem We want to display the correlation images in the picture-boxes.
Rem This is done by making them into BMP-bitmaps
Rem Give the BMP-file a name
'Dim c_file As String
'c_file = "c:\data\rkuva" & CStr(i) & ".bmp"
  
Rem Create the file
'Call old_create_bmp(CLng(0), CLng(End_Col - Start_Col), CLng(Start_Row - End_Row), Lkuva(), c_file)
Rem Load the image to the picture-Box
'Form1.Picture1(i).Picture = LoadPicture(c_file)

Rem Update structs
cor_ima_info(i).sub_width = End_Col - Start_Col + 1                  ' sub-image (to be stored in an array) width
cor_ima_info(i).sub_height = Start_Row - End_Row + 1                 ' sub-image height
cor_ima_info(i).Filename = "c:\data\ccor_ima" & CStr(i) & ".raw"     ' filename to be opened, containing raw-data (RGB)
cor_ima_info(i).Color = 0                                            ' 1 for 24-bit color, 0 for greyscale
cor_ima_info(i).sub_c_col = 1                                     ' sub-image will be centered at this col when program initiates
cor_ima_info(i).sub_c_row = 1                               ' sub-image will be centered at this row when program initiates
cor_ima_info(i).o_col = image_info(i).o_col + Start_Col     ' the col value for the sub-image origo, in the main image coord. system with Y(row)-axis pointing down
cor_ima_info(i).o_row = ((image_info(i).Height - 1) - (image_info(i).o_row + (image_info(i).sub_height - 1))) + Start_Row                                           ' the row value for the sub-image origo, in the main image coord. system
cor_ima_info(i).Width = image_info(i).Width                          ' width of the main image
cor_ima_info(i).Height = image_info(i).Height                        ' heigth of the main image
cor_ima_info(i).o_row = ((image_info(i).Height - 1) - (image_info(i).o_row)) - End_Row                                            ' the row value for the sub-image origo, in the main image coord. system
cor_ima_info(i).c = image_info(i).c                 ' camera constant
cor_ima_info(i).x_ps = image_info(i).x_ps         ' in FC-coordinates the x-coordinate of the PPA-point (principal point)
cor_ima_info(i).y_ps = image_info(i).y_ps        ' in FC-coordinates the y-coordinate of the PPA-point
cor_ima_info(i).lambda = image_info(i).lambda      ' Helmert rotation-angle, [rad]
cor_ima_info(i).alpha = image_info(i).alpha        ' Helmert scale factor
cor_ima_info(i).mean_x = image_info(i).mean_x      ' Helmert mean x of camera coords
cor_ima_info(i).mean_y = image_info(i).mean_y      ' Helmert mean y of camera coords
cor_ima_info(i).X_mean = image_info(i).X_mean      ' Helmert mean ROW of image coords
cor_ima_info(i).Y_mean = image_info(i).Y_mean      ' Helmert mean COL of image coords
cor_ima_info(i).a_ = image_info(i).a_            ' Affine a
cor_ima_info(i).b_ = image_info(i).b_            ' Affine b
cor_ima_info(i).c_ = image_info(i).c_            ' Affine c
cor_ima_info(i).d_ = image_info(i).d_            ' Affine d
cor_ima_info(i).e_ = image_info(i).e_            ' Affine e
cor_ima_info(i).f_ = image_info(i).f_            ' Affine f
cor_ima_info(i).omega = image_info(i).omega      ' ext. orientation angle omega (X)
cor_ima_info(i).phi = image_info(i).phi         ' ext. orientation angle phi (Y)
cor_ima_info(i).kappa = image_info(i).kappa      ' ext. orientation angle kappa (Z)
cor_ima_info(i).Xo = image_info(i).Xo            ' proj. center X-coord.
cor_ima_info(i).Yo = image_info(i).Yo          ' proj. center Y-coord.
cor_ima_info(i).Zo = image_info(i).Zo          ' proj. center Z-coord.

cor_win_info(i).win_o_col = 0                   ' the col value(in main image coord system) of the origo in the picture-box
cor_win_info(i).win_o_row = 0
cor_win_info(i).win_width = 0                   ' End_Col - Start_Col + 1                    ' width of the picture-box
cor_win_info(i).win_height = 0                  'Start_Row - End_Row + 1
cor_win_info(i).pan_x = 1#                      ' Zoom factor pan_x = pan_y , 1 = No Zooming
cor_win_info(i).pan_y = 1#

Rem Debugging to see that indeces match!

Imagesdisplayed(i) = CORR_IMA

Next j ' next image
Call Create_XYZ_Point_Set_Batch
End Sub

Public Sub Create_XYZ_Point_Set_Batch()

Rem This routine creates a 3D-point mesh from where seacrh for crowns will be conducted
Rem BATCH-version

Dim i As Integer
Dim origoX As Double, origoY As Double, origoZ As Double
Dim gridXextent As Double, gridYextent As Double, gridZextent As Double
Dim gridXtess As Double, gridYtess As Double, gridZtess As Double, XYrotangle As Double
Dim filename_str As String
Dim length As Long

Rem Check that DEM is available, if not exit
 If RasterModelReady = False Then
  MsgBox ("Read height model first!")
  Exit Sub
 End If

Rem Assign values of circular plot's center to local variables from the global-struct
origoX = B_plotcenter.x
origoY = B_plotcenter.y

Rem Sanity checking
If Abs(origoX) < 1 Or Abs(-origoY) < 1 Then
 MsgBox ("Are the plotcenter values ok?")
 Exit Sub
End If

Rem From the mean tree selected, compute the trees height, call it meanheight
Meanheight = Z_sol - getheight(X_sol, Y_sol)
OV.Meanheight = Meanheight

Rem XY-extent of the 3D-mesh is defined here
gridXextent = CLng(square_side * 0.65)
gridYextent = CLng(square_side * 0.65)

Rem Get user defined parameters for the depth, Z-asymmetry and mesh density
Rem If an erroneous value is given, return here


Dim apu As Double

For gridZextent = B_ZDepthmin To B_ZDepthmax Step B_ZDepthstep
 For Zasymmetry = B_ZAsymin To B_ZAsymax Step B_ZAsystep
   For apu = B_Meshmin To B_Meshmax Step B_Meshstep
Rem ********* PARAMETER ************
' gridZextent = CDbl(Form1.Text8.Text)
OV.ZDepth = gridZextent

Rem ********* PARAMETER ************
' Zasymmetry = CDbl(Form1.Text9.Text)
OV.Zasym = Zasymmetry

Rem ********* PARAMETER ************
Rem equal mesh-distance in all three directions

    gridXtess = CDbl(apu): gridYtess = CDbl(apu): gridZtess = CDbl(apu)
    OV.Meshdist = gridXtess

    XYrotangle = B_plotcenter.XYangle

Rem The 3D-mesh is computed into an point3D-array (global) SearchSpaceData().
   Call MAKE3DPOINTSET(origoX, origoY, origoZ, gridXextent, gridYextent, gridZextent, gridXtess, gridYtess, gridZtess, XYrotangle, Zasymmetry, Meanheight)

   Form1.Label10.Caption = "Calling BK-proj"


   Call Compute_Back_Projections_Batch

  Next apu
 Next Zasymmetry
Next gridZextent

End Sub

Public Sub Compute_Back_Projections_Batch()


Rem This routine computes backprojections from the 3D-point mesh to the aerial photos, now
Rem converted into cross-correlation images
 

'On Error GoTo Error_In_Compute_Back_Projections

Dim Num_of_ima As Integer
ReDim images_involved(1 To MAXIMA) As Integer
Dim p_x As Double, p_y As Double
Dim i As Integer, MaxPoints As Long
Dim row As Integer, col As Integer

Rem Declare storage. As many elements as there are points in the 3D-data
MaxPoints = UBound(SearchSpaceData, 1) + 1

ReDim a_tau(0 To MaxPoints) As Single           ' these arrays start from index 1 (sorting algoritms in fortran)
ReDim R_tau(1 To MaxPoints, 1 To 6) As Double   ' and not rewritten to take 0-start into account

Rem Check which images are selected to be included in matching. Check check-boxes.
Num_of_ima = 0
For i = 0 To NumOfImages - 1
 If Form1.Check1(i).Value = 1 Then
  Num_of_ima = Num_of_ima + 1:
  images_involved(Num_of_ima) = i
 End If
Next i

Rem Assign this number to OV-vector; and information about images
OV.NImagesInMatch = Num_of_ima
Dim j As Integer
For j = 1 To Num_of_ima
 i = images_involved(j)
 OV.ImInfo(j - 1).ImCode = image_info(i).ImageCode
 OV.ImInfo(j - 1).SunA = image_info(i).Sun_azimuth
 OV.ImInfo(j - 1).SunE = image_info(i).Sun_elevation
 OV.ImInfo(j - 1).x0 = image_info(i).Xo
 OV.ImInfo(j - 1).y0 = image_info(i).Yo
 OV.ImInfo(j - 1).z0 = image_info(i).Zo
Next j

Rem Let's loop thru the data point by point
Dim k As Long


Dim cl As Long
Dim af(0 To 5) As Double, ori(0 To 6) As Double, cimainfo(0 To 3) As Double

'GoTo skipDll
For j = 1 To Num_of_ima
 i = images_involved(j)
 af(0) = image_info(i).a_: af(1) = image_info(i).b_: af(2) = image_info(i).c_
 af(3) = image_info(i).d_: af(4) = image_info(i).e_: af(5) = image_info(i).f_
 ori(0) = image_info(i).omega: ori(1) = image_info(i).phi: ori(2) = image_info(i).kappa
 ori(3) = image_info(i).Xo: ori(4) = image_info(i).Yo: ori(5) = image_info(i).Zo
 ori(6) = image_info(i).c
 cimainfo(0) = cor_ima_info(i).Height
 cimainfo(1) = cor_ima_info(i).o_col   ' centercol
 cimainfo(2) = cor_ima_info(i).o_row   ' centerrow
 cimainfo(3) = UBound(cor_arr, 2) + 1
 cl = MYFUNC_COMPUTEBKPROJ(ByVal CLng(i), ByVal MaxPoints, af(0), ori(0), cimainfo(0), a_tau(1), SearchSpaceData(0).x, cor_arr(0, 0, 0))
Next j

Rem cor_arr is computed, update r_tau() and a_tau
Rem ***************  HERE IS A LOOONG VB-LOOP!! **************************************
Rem Takes about .14 secs for 300.000 points
For k = 0 To MaxPoints - 1
 a_tau(k + 1) = a_tau(k + 1) / CDbl(Num_of_ima)
 R_tau(k + 1, 4) = SearchSpaceData(k).x
 R_tau(k + 1, 5) = SearchSpaceData(k).y
 R_tau(k + 1, 6) = SearchSpaceData(k).z
Next k

ReDim n_tau(0 To MaxPoints) As Long
n_candidate_points = MaxPoints

Rem Sort elements of a_tau(), return sorted indeces in array n_tau()

Rem n_tau has elements 0 to Maxpoints (0'th just for the C-dll)
Rem atau has 0 to to maxpoints (0'th just for the C-dll)

Rem VB-BAS version of sorting
Rem Call indexx(ByVal MaxPoints, a_tau(), n_tau())
Rem C-dll indexx heapsort
Dim apu As Double
apu = MYFUNC_INDEXX(CLng(MaxPoints), a_tau(0), n_tau(0))
Rem C-dll is 2.6 / 0.12 = 22 times faster

Rem Turn "Hourglass" into regular Arrow Pointer

Form1.Label10.Caption = "3D-correlation computed and sorted, ready for tree top extraction"

Call Find_clusters_Batch

Exit Sub

Error_In_Compute_Back_Projections:
Form1.MousePointer = 1
MsgBox ("An error occurred in computing back-projections!")
Form1.Label10.Caption = "3D-correlation computation failed"
End Sub

Public Sub Find_clusters_Batch()

Rem *****************************************************************************
Rem Clustering of the 3D-volumetric correspondence data into tree top candidates.
Rem
Rem a_tau() holds correlation data
Rem n_tau() holds the sorted indeces
Rem r_tau() holds the coordinate data

Dim N_CAND_MAX As Integer, N_CLUS_MAX As Integer

N_CAND_MAX = 2000
N_CLUS_MAX = 2000

Rem clus(N,M) array holds the cluster data. There's room for N clusters consisting of M-points (X,Y,Z)

Rem Assign a value for xy_thin. If a new point is farther than xy_thin from the center of the
Rem cluster, it belongs to a new one (assuming its value is above r_limit)

For xy_thin = B_XYthinmin To B_XYthinmax Step B_XYthinstep
 For r_limit = B_Rlimitmin To B_Rlimitmax Step B_Rlimitstep

ReDim clus(0 To N_CLUS_MAX, 1) As Single
ReDim cluscoords(0 To N_CLUS_MAX) As point3D
ReDim atausum(0 To N_CLUS_MAX) As Double

OV.XYthin = xy_thin
OV.Rlimit = r_limit


Rem Variable Plot_Points_Above_R_limit when set to true will display all candidate
Rem locations with correspondence value above r_limit on the aerial photos
'Dim Plot_Points_Above_R_limit As Boolean
'Plot_Points_Above_R_limit = False


Dim Image As Integer

Rem Loop thuru the candidate points, the 3D-data set, a_tau()-array
Rem in ascending order of correspondence, i now has the number of points

ReDim rclus(0 To N_CLUS_MAX + 1) As Single
Dim Nclus As Long
Dim Match2Ddist As Double, MatchZdist As Double
Match2Ddist = 1.3: MatchZdist = 3
plotdata(0) = B_plotcenter.x
plotdata(1) = B_plotcenter.y
plotdata(2) = B_plotcenter.z
plotdata(3) = Plotradius
plotdata(4) = Match2Ddist
plotdata(5) = MatchZdist
plotdata(6) = CDbl(OV.NImagesInMatch)
plotdata(7) = CDbl(OV.ModelTreeNum)
plotdata(8) = CDbl(OV.ModelTreeX)
plotdata(9) = CDbl(OV.ModelTreeY)
plotdata(10) = CDbl(OV.ModelTreeZ)
plotdata(11) = CDbl(OV.TWidth)
plotdata(12) = CDbl(OV.EllZasym)
plotdata(13) = CDbl(OV.Zdiff)
plotdata(14) = CDbl(OV.ZDepth)
plotdata(15) = CDbl(OV.Zasym)
plotdata(16) = CDbl(OV.Meshdist)
plotdata(17) = CDbl(OV.Meanheight)

 

Dim apu As Double
'apu = MYFUNC_FINDCLUSTERS(CLng(n_candidate_points), CDbl(xy_thin), CDbl(r_limit), plotdata(0), n_tau(0), a_tau(0), Nclus, SearchSpaceData(0).X, atausum(0), cluscoords(0).X, rclus(0))
mc = apu

Rem Done with forming clusters. Update the label on the main -form.
Form1.Label10.Caption = "Found " & mc & " clusters"
DoEvents


' OV.DigString = DigitString

 Next r_limit
Next xy_thin


End Sub

